# -*- coding: utf8 -*-

#-----------------------------------------
# This is a part of Collège 3D project.
# Author:       Pascal Peter
# Copyright:    (C) 2003-2016 Pascal Peter
# Licence:      GNU General Public Licence version 3
# Website:      http://pascal.peter.free.fr/
# Email:        pascal.peter at free.fr
#-----------------------------------------

"""
DESCRIPTION :
    Écran final.
"""

# **************************************************
#       IMPORTATION DES MODULES UTILES
# **************************************************
from time import time

import bge

import utils, input_controller



# **************************************************
#       CONTRÔLES DU JEU
# **************************************************
scene = None



# **************************************************
#       FONCTIONS UTILES
# **************************************************
def postDrawTexts():
    """
    affichage des textes.
    """
    utils.postDrawTexts('quit_loop')



# **************************************************
#       FONCTION PRINCIPALE
# **************************************************
def main():
    # ---------------------------------------------------------
    # RÉCUPÉRATION DE L'ÉTAT DU JEU
    # ---------------------------------------------------------
    state = bge.logic.globalDict['GAME'].get('state', '')
    if not(state in ('quit_first', 'quit_loop')):
        bge.logic.globalDict['GAME']['state'] = 'quit_first'

    # ---------------------------------------------------------
    # PREMIER LANCEMENT
    # ---------------------------------------------------------
    if bge.logic.globalDict['GAME']['state'] == 'quit_first':
        # on masque la souris :
        bge.render.showMouse(False)
        # valeurs initiales (lues depuis le fichier de config si existe) :
        utils.loadSettings()
        lang = bge.logic.globalDict['MENU']['lang']
        global scene
        scene = bge.logic.getCurrentScene()
        # affichage des textes :
        scene.post_draw += [postDrawTexts]
        bge.logic.globalDict['TEXTS'] = {}
        utils.setText('progName', color=utils.colors['orange'], width=9, position=(0.15, 0.25))
        utils.setText('goodBye', color=utils.colors['blue'], width=8, position=(0.15, 0.9))
        # initialisation des timers :
        bge.logic.globalDict['TEMP']['initialTime'] = time()
        bge.logic.globalDict['TEMP']['actualTime'] = 0
        bge.logic.globalDict['TEMP']['timeSpecific'] = {1: False, 2: False, 4: False}
        # initialisation terminée :
        bge.logic.globalDict['GAME']['state'] = 'quit_loop'

    # ---------------------------------------------------------
    # BOUCLE DES ÉVÉNEMENTS
    # ---------------------------------------------------------
    if bge.logic.globalDict['GAME']['state'] != 'quit_loop':
        return
    inputState = input_controller.inputManagement('splash')
    # pour faire un screencast :
    if inputState['SCREENSHOT']:
        utils.makeScreenshot()
    actualTime = int(round(time() - bge.logic.globalDict['TEMP']['initialTime']))
    if actualTime > bge.logic.globalDict['TEMP']['actualTime']:
        bge.logic.globalDict['TEMP']['actualTime'] = actualTime
        for i in bge.logic.globalDict['TEMP']['timeSpecific']:
            if (actualTime >= i) and not(bge.logic.globalDict['TEMP']['timeSpecific'][i]):
                bge.logic.globalDict['TEMP']['timeSpecific'][i] = True
                if i == 1:
                    utils.setText('progName', text=utils.PROGNAME)
                elif i == 2:
                    lang = bge.logic.globalDict['MENU']['lang']
                    utils.setText('goodBye', text=utils.tr('other', 'Goodbye...', lang))
                elif i == 4:
                    utils.freeAllLibs(doAll=True)
                    bge.logic.endGame()


